%For figure 5.1, run this m file and save image and then zoom and save
%image:

close all;
clear all;
figure(1);
z1 = [];
z2 = [];
z3 = [];
z4 = [];
%z5 = [];
for T=0:0.01:2*pi-0.01
    z1 = [z1; roots([1 1-exp(1i*T)])];
    z2 = [z2; roots([1/2 1 1-exp(1i*T)])];
    z3 = [z3; roots([1/6 1/2 1 1-exp(1i*T)])];    
    z4 = [z4; roots([1/24 1/6 1/2 1 1-exp(1i*T)])];    
   % z5 = [z5; roots([1/104 1/24 1/6 1/2 1 1-exp(1i*T)])]; 
end

plot(real(z1),imag(z1),'.r','MarkerSize',5,'LineWidth',2);
xlabel('k*Re(\lambda)','FontSize',14);
ylabel('k*Im(\lambda)','FontSize',14);
hold on;
plot(real(z2),imag(z2),'.c','MarkerSize',5,'LineWidth',2);
plot(real(z3),imag(z3),'.g','MarkerSize',5,'LineWidth',2);
plot(real(z4),imag(z4),'.b','MarkerSize',5,'LineWidth',2);
%plot(real(z5),imag(z5),'.g','MarkerSize',5);
plot([0 0],[min(imag(z4))-0.5 max(imag(z4))+0.5],'--k','LineWidth',2);
set(gca,'FontSize',14);
hold off;
axis([-3.5 1 -3.5 3.5]);
