clear all;
close all;

for(method = 11:12)
BC = 1;
syms h a s 
l_a  = 1/a;    l_h2 = 1/h^2; 
l76  = 7/6;    l_12 = 1/12;
a_12 = a/12;  a_6h2 = a/(6*h^2);
par  = [];

N = 7;
M = 7;
K = 7;

%ONE-DIMENSIONAL
V  = sym(zeros(N,M,K));
A  = sym(zeros(N*M*K,N*M*K));
U0 = sym(zeros(N,M,K));

aj=0;
for k=1:K
  for m=1:M
    for n=1:N
       aj = aj+1; 
       U0(n,m,k) = 1;   
       U1 = NLSE3D_Fsym(U0,V,h,s,a,method,BC,l_h2,a_12,a_6h2,l_a);
       A(:,aj) = U1(:);
       U0(n,m,k) = 0;
    end
  end
end

A = simplify(A*(h^2/(a*1i)));
A2 = A;
a2j = 1;
for j=1:N*M*K
    if(sum([abs(A(j,1:j-1)),abs(A(j,j+1:end))])==0)
        A2(a2j,:) = [];
        A2(:,a2j) = [];
        a2j = a2j-1;        
    end    
    a2j = a2j+1;
end
[NMK2,NMK22] = size(A2);

Gcircles = sym(zeros(NMK2,4));

for j=1:NMK2
    Gcircles(j,1) = A2(j,j);
    Gcircles(j,2) = sum([abs(A2(j,1:j-1)),abs(A2(j,j+1:end))]);
    Gcircles(j,3) = A2(j,j) + sum([abs(A2(j,1:j-1)),abs(A2(j,j+1:end))]);
    Gcircles(j,4) = A2(j,j) - sum([abs(A2(j,1:j-1)),abs(A2(j,j+1:end))]);    
end
Gcircles = sym(unique(Gcircles,'rows'))
%Gcircles
L = 0; 
Bx = 1;
By = 1;
Bz = 1;
Bc = 1;
Dx = 1;
Dy = 1;
Dz = 1;
Dc = 1;
A  = double(sym(eval(A)));
A2 = double(sym(eval(A2)));
figure(method)
spy(A)
axis([1 N*M*K 1 N*M*K]);
xlabel(' ');
set(gca,'YTick',[1 floor(N*M*K/2) floor(N*M*K)]);
set(gca,'XTick',[1 floor(N*M*K/2) floor(N*M*K)]);
figure(method+10)
spy(A2)
axis([1 NMK2 1 NMK2]);
xlabel(' ');
set(gca,'YTick',[1 floor(NMK2/2) NMK2]);
set(gca,'XTick',[1 floor(NMK2/2) NMK2]);


Gcircles = double(eval(Gcircles));
Gcircles = sym(unique(Gcircles,'rows'))
sym(max(max(abs(double(Gcircles(:,3:4))))))

G12 = 12*sort(unique(Gcircles(:,3:4)))

end